import java.util.ArrayList;

/**
 * Klasse Container
 * in einen Container koennen Stuecke eingefuellt werden
 * 
 * @author claus albowski
 * @version 5'2015
 */
public class Container
{
    private int fassung;
    private ArrayList<Stueck> inhalt;

    /**
     * Konstruktor fuer Objekte der Klasse Container
     */
    public Container(int fassung)
    {
        this.fassung = fassung;
        inhalt = new ArrayList();
    }

    /**
     * get-Methode fuer das Fassungsvermoegen des Containers
     */
    public int gibGroesse(){
        return fassung;
    }
    
   /**
    * get-Methode fuer den Gesamtwert der Fuellung des Containers
    */
    public int gibFuellung() {
        int fuellung=0;
        for (Stueck stueck : inhalt) fuellung+=stueck.gibGroesse();
        return fuellung;
    }
    
   /**
    * get-Methode fuer die eingefuellten Stuecke
    */
    public ArrayList<Stueck> gibStuecke() {
        return inhalt;
    }
    
    /**
     * fuellt ein Stueck ein
     * veraendernde Methode fuer die Fuellung
     */
    public boolean fuelleEin(Stueck stueck){
        if (gibFuellung()+stueck.gibGroesse()>fassung) return false;
        else {
            inhalt.add(stueck);
            return true;
        }
    }
    
    /**
     * gibt zurueck, ob der Container exakt voll ist
     * sondierende Methode
     */
    public boolean istVoll(){
        return gibFuellung()==fassung;
    }
}
