import java.util.ArrayList;

/**
 * Die Klasse Controller
 * verwaltet das Projekt
 * 
 * @author claus albowski
 * @version 5'2015
 */
public class Controller
{
    private ArrayList<Stueck> stuecke, reste;
    private Container container;
    
    /**
     * Konstruktor fuer Objekte der Klasse Controller
     */
    public Controller()
    {
        stuecke = new ArrayList();
        reste = new ArrayList();
    }
    
    /**
     * erzeugt einen neuen Container
     */
    public void neuerContainer(int fassungsvermoegen){
        container = new Container(fassungsvermoegen);
    }

    /**
     * erzeugt ein neues Stueck
     */
    public void neuesStueck(int volumen){
        stuecke.add(new Stueck(volumen));
    }

    /**
     * fuellt den Container (greedy)
     */
    public boolean fuelle()
    {
        for (Stueck stueck: stuecke) 
        if (!container.fuelleEin(stueck)) reste.add(stueck);
        return container.istVoll();
    }
    
    /**
     * get-Methode fuer die nicht eingefuellten Stuecke
     */
    public ArrayList<Stueck> gibReste()
    {
        return reste;
    }
    
    /**
     * zeigt die nicht eingefuellten Stuecke an
     */
    public String zeigeReste()
    {
        String resteString ="Reste:";
        for (Stueck stueck : reste) resteString += " "+stueck.gibGroesse();
        return resteString;
    }
    
    /**
     * zeigt das Ergebnis an
     */
    public void zeigeErgebnis(){
        System.out.println("Der Container mit dem Fassungsvermoegen: "
        +container.gibGroesse()
        +" enthaelt: ");
        for (Stueck stueck : container.gibStuecke())
        System.out.print(stueck.gibGroesse()+" ");
        System.out.println();
        if (container.istVoll()) System.out.println("Er ist vollstaendig gefuellt.");
        else System.out.println("Er konnte nicht vollstaendig gefuellt werden. "
        +zeigeReste());
    }
}
